<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class CalendarioAgendamentoFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function fct_apropagendamento_calendario() 
    {
        $sql = "SELECT
                    '#008904' AS CORCARD,
                    FCT_APROPAGENDAMENTO.NRAPROPAGENDAMENTO,
                    FCT_CONTRATO.NRSEQCONTRATO,
                    FCT_APROPAGENDAMENTO.NRRECURSOSAGENDCONT,
                    FCT_CONTRATO.DSREFERENCIACONT AS AGENDAMENTO,
                    CLIENTE.NMPRINCIPALPARC AS NMCLIENTE,
                    ESTRUTURAM.NMESTRUTURAM,
                    FCT_APROPAGENDAMENTO.NRPARCNEGRECURSO,
                    PARCNEGOCIO.NMPRINCIPALPARC,
                    ESTRUTURAM.NRESTRUTURAM,
                    TO_CHAR(FCT_APROPAGENDAMENTO.DTAPROPRIACAO, 'DD/MM/YYYY') AS DTAPROPRIACAO,
                    FCT_APROPAGENDAMENTO.IDSTATUSAPROPRIACAO,
                    FCT_APROPAGENDAMENTO.QTHORASAPROPRIADAS,
                    FCT_AGENDRECURSOCONT.DTINIAGENDAMENTO,
                    FCT_AGENDRECURSOCONT.DTFIMAGENDAMENTO,
                    TO_CHAR(FCT_RECURSOSAGENDCONT.DTINIAGENDRECURSO, 'DD/MM/YYYY') || ' ao ' || TO_CHAR(FCT_RECURSOSAGENDCONT.DTFIMAGENDRECURSO, 'DD/MM/YYYY') AS PERIODO,
                    FCT_APROPAGENDAMENTO.NRPARCINTERLOCUTOR,
                    FCT_RECURSOSAGENDCONT.DSATIVIDADESAGEND,
                    FCT_APROPAGENDAMENTO.NRORG
                FROM
                    FCT_APROPAGENDAMENTO
                    LEFT JOIN PARCNEGOCIO ON PARCNEGOCIO.NRPARCNEGOCIO = FCT_APROPAGENDAMENTO.NRPARCNEGRECURSO AND PARCNEGOCIO.NRORG = FCT_APROPAGENDAMENTO.NRORG
                    LEFT JOIN FCT_RECURSOSAGENDCONT ON FCT_RECURSOSAGENDCONT.NRRECURSOSAGENDCONT = FCT_APROPAGENDAMENTO.NRRECURSOSAGENDCONT AND FCT_RECURSOSAGENDCONT.NRORG = FCT_APROPAGENDAMENTO.NRORG
                    LEFT JOIN FCT_AGENDRECURSOCONT ON FCT_AGENDRECURSOCONT.NRAGENDRECURSOCONT = FCT_RECURSOSAGENDCONT.NRAGENDRECURSOCONT AND FCT_AGENDRECURSOCONT.NRORG = FCT_RECURSOSAGENDCONT.NRORG
                    LEFT JOIN FCT_CONTRATO ON FCT_CONTRATO.NRSEQCONTRATO = FCT_AGENDRECURSOCONT.NRSEQCONTRATO AND FCT_CONTRATO.NRORG = FCT_AGENDRECURSOCONT.NRORG
                    LEFT JOIN PARCNEGOCIO CLIENTE ON CLIENTE.NRPARCNEGOCIO = FCT_CONTRATO.NRPARCNEGOCIO AND CLIENTE.NRORG = FCT_CONTRATO.NRORG
                    LEFT JOIN ESTRUTURAM ON ESTRUTURAM.NRESTRUTURAM = FCT_AGENDRECURSOCONT.NRESTRUTURAM AND ESTRUTURAM.NRORG = FCT_AGENDRECURSOCONT.NRORG
                    -- RETIRAR DEPOIS
                    -- WHERE DTAPROPRIACAO = '06/06/2022'
                    ORDER BY NMCLIENTE";

         return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function fct_apropagendamento_cal($filtroCHAVE, $filtroNRSEQCONTRATO, $filtroNRESTRUTURAM, $filtroDTINIAGENDAMENTO, $filtroDTFIMAGENDAMENTO) 
    {
        $sql = "SELECT DISTINCT
                    '#008904' AS CORCARD,
                    FCT_APROPAGENDAMENTO.NRAPROPAGENDAMENTO,
                    FCT_CONTRATO.NRSEQCONTRATO,
                    FCT_APROPAGENDAMENTO.NRRECURSOSAGENDCONT,
                    FCT_CONTRATO.DSREFERENCIACONT AS AGENDAMENTO,
                    CLIENTE.NMPRINCIPALPARC AS NMCLIENTE,
                    ESTRUTURAM.NMESTRUTURAM,
                    FCT_APROPAGENDAMENTO.NRPARCNEGRECURSO,
                    PARCNEGOCIO.NMPRINCIPALPARC,
                    ESTRUTURAM.NRESTRUTURAM,
                    TO_CHAR(FCT_APROPAGENDAMENTO.DTAPROPRIACAO, 'DD/MM/YYYY') AS DTAPROPRIACAO,
                    FCT_APROPAGENDAMENTO.IDSTATUSAPROPRIACAO,
                    FCT_APROPAGENDAMENTO.QTHORASAPROPRIADAS,
                    FCT_AGENDRECURSOCONT.DTINIAGENDAMENTO,
                    FCT_AGENDRECURSOCONT.DTFIMAGENDAMENTO,
                    TO_CHAR(FCT_RECURSOSAGENDCONT.DTINIAGENDRECURSO, 'DD/MM/YYYY') || ' ao ' || TO_CHAR(FCT_RECURSOSAGENDCONT.DTFIMAGENDRECURSO, 'DD/MM/YYYY') AS PERIODO,
                    FCT_APROPAGENDAMENTO.NRPARCINTERLOCUTOR,
                    FCT_RECURSOSAGENDCONT.DSATIVIDADESAGEND,
                    FCT_APROPAGENDAMENTO.NRORG,
                    FCT_CONTRATO.NRCONTRATOFCT || ' - ' || FCT_CONTRATO.DSREFERENCIACONT || ' - ' || CLIENTE.NMPRINCIPALPARC as CONTRATO_GRID,
                    FCT_CONTRATO.NRCONTRATOFCT
                FROM
                    FCT_APROPAGENDAMENTO
                    LEFT JOIN PARCNEGOCIO ON PARCNEGOCIO.NRPARCNEGOCIO = FCT_APROPAGENDAMENTO.NRPARCNEGRECURSO AND PARCNEGOCIO.NRORG = FCT_APROPAGENDAMENTO.NRORG
                    LEFT JOIN FCT_RECURSOSAGENDCONT ON FCT_RECURSOSAGENDCONT.NRRECURSOSAGENDCONT = FCT_APROPAGENDAMENTO.NRRECURSOSAGENDCONT AND FCT_RECURSOSAGENDCONT.NRORG = FCT_APROPAGENDAMENTO.NRORG
                    LEFT JOIN FCT_AGENDRECURSOCONT ON FCT_AGENDRECURSOCONT.NRAGENDRECURSOCONT = FCT_RECURSOSAGENDCONT.NRAGENDRECURSOCONT AND FCT_AGENDRECURSOCONT.NRORG = FCT_RECURSOSAGENDCONT.NRORG
                    LEFT JOIN FCT_CONTRATO ON FCT_CONTRATO.NRSEQCONTRATO = FCT_AGENDRECURSOCONT.NRSEQCONTRATO AND FCT_CONTRATO.NRORG = FCT_AGENDRECURSOCONT.NRORG
                    LEFT JOIN PARCNEGOCIO CLIENTE ON CLIENTE.NRPARCNEGOCIO = FCT_CONTRATO.NRPARCNEGOCIO AND CLIENTE.NRORG = FCT_CONTRATO.NRORG
                    LEFT JOIN ESTRUTURAM ON ESTRUTURAM.NRESTRUTURAM = FCT_AGENDRECURSOCONT.NRESTRUTURAM AND ESTRUTURAM.NRORG = FCT_AGENDRECURSOCONT.NRORG
                    WHERE FCT_APROPAGENDAMENTO.IDATIVO = 'S' 
                    -- WHERE DTAPROPRIACAO = '06/06/2022'
                    $filtroCHAVE
                    $filtroNRSEQCONTRATO
                    $filtroNRESTRUTURAM
                    $filtroDTINIAGENDAMENTO
                    $filtroDTFIMAGENDAMENTO
                    ORDER BY NMCLIENTE";

         return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function fct_relacestruturacont_estruturam($parametros)
    {
        $sql = "SELECT DISTINCT
                    REL.NRESTRUTURAM,
                    EST.NMESTRUTURAM,
                    REL.NRORG
                FROM FCT_RELACESTRUTURACONT REL
                    JOIN ESTRUTURAM EST ON REL.NRESTRUTURAM = EST.NRESTRUTURAM AND REL.NRORG = EST.NRORG
                WHERE
                    ((REL.NRSEQCONTRATO = :NRSEQCONTRATO) OR (:NRSEQCONTRATO IS NULL))";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function find_parceiro() 
    {
        $sql = "SELECT DISTINCT
                    FCT_APROPAGENDAMENTO.NRPARCNEGRECURSO,
                    PARCNEGOCIO.NMPRINCIPALPARC
                FROM FCT_APROPAGENDAMENTO
                    LEFT JOIN PARCNEGOCIO ON PARCNEGOCIO.NRPARCNEGOCIO = FCT_APROPAGENDAMENTO.NRPARCNEGRECURSO AND PARCNEGOCIO.NRORG = FCT_APROPAGENDAMENTO.NRORG
                    LEFT JOIN FCT_RECURSOSAGENDCONT ON FCT_RECURSOSAGENDCONT.NRRECURSOSAGENDCONT = FCT_APROPAGENDAMENTO.NRRECURSOSAGENDCONT AND FCT_RECURSOSAGENDCONT.NRORG = FCT_APROPAGENDAMENTO.NRORG
                    LEFT JOIN FCT_AGENDRECURSOCONT ON FCT_AGENDRECURSOCONT.NRAGENDRECURSOCONT = FCT_RECURSOSAGENDCONT.NRAGENDRECURSOCONT AND FCT_AGENDRECURSOCONT.NRORG = FCT_RECURSOSAGENDCONT.NRORG
                    LEFT JOIN FCT_CONTRATO ON FCT_CONTRATO.NRSEQCONTRATO = FCT_AGENDRECURSOCONT.NRSEQCONTRATO AND FCT_CONTRATO.NRORG = FCT_AGENDRECURSOCONT.NRORG
                    LEFT JOIN PARCNEGOCIO CLIENTE ON CLIENTE.NRPARCNEGOCIO = FCT_CONTRATO.NRPARCNEGOCIO AND CLIENTE.NRORG = FCT_CONTRATO.NRORG
                    LEFT JOIN ESTRUTURAM ON ESTRUTURAM.NRESTRUTURAM = FCT_AGENDRECURSOCONT.NRESTRUTURAM AND ESTRUTURAM.NRORG = FCT_AGENDRECURSOCONT.NRORG
                    ORDER BY PARCNEGOCIO.NMPRINCIPALPARC";

         return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function fct_view_recursos() 
    {
        $sql = "SELECT
                    NMRECURSO,
                    CODRECURSO,
                    CHAVE,
                    CDEMPRESA,
                    CDTIPO,
                    NMTIPO,
                    NRORG
                FROM FCT_VIEW_RECURSOS
                WHERE CDTIPO = 1 AND CODRECURSO IS NOT NULL";

         return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
    
    public function fct_contrato_grid() 
    {
        $sql = "SELECT
                    DISTINCT FCT_CONTRATO.NRSEQCONTRATO,
                    FCT_CONTRATO.NRCONTRATOFCT,
                    FCT_CONTRATO.NRCONTRATOFCT || ' - ' || FCT_CONTRATO.DSREFERENCIACONT || ' - ' || CLIENTE.NMPRINCIPALPARC as CONTRATO_GRID
                FROM
                    FCT_APROPAGENDAMENTO
                    LEFT JOIN PARCNEGOCIO ON PARCNEGOCIO.NRPARCNEGOCIO = FCT_APROPAGENDAMENTO.NRPARCNEGRECURSO AND PARCNEGOCIO.NRORG = FCT_APROPAGENDAMENTO.NRORG
                    LEFT JOIN FCT_RECURSOSAGENDCONT ON FCT_RECURSOSAGENDCONT.NRRECURSOSAGENDCONT = FCT_APROPAGENDAMENTO.NRRECURSOSAGENDCONT AND FCT_RECURSOSAGENDCONT.NRORG = FCT_APROPAGENDAMENTO.NRORG
                    LEFT JOIN FCT_AGENDRECURSOCONT ON FCT_AGENDRECURSOCONT.NRAGENDRECURSOCONT = FCT_RECURSOSAGENDCONT.NRAGENDRECURSOCONT AND FCT_AGENDRECURSOCONT.NRORG = FCT_RECURSOSAGENDCONT.NRORG
                    LEFT JOIN FCT_CONTRATO ON FCT_CONTRATO.NRSEQCONTRATO = FCT_AGENDRECURSOCONT.NRSEQCONTRATO AND FCT_CONTRATO.NRORG = FCT_AGENDRECURSOCONT.NRORG
                    LEFT JOIN PARCNEGOCIO CLIENTE ON CLIENTE.NRPARCNEGOCIO = FCT_CONTRATO.NRPARCNEGOCIO AND CLIENTE.NRORG = FCT_CONTRATO.NRORG
                    LEFT JOIN ESTRUTURAM ON ESTRUTURAM.NRESTRUTURAM = FCT_AGENDRECURSOCONT.NRESTRUTURAM AND ESTRUTURAM.NRORG = FCT_AGENDRECURSOCONT.NRORG
                    ORDER BY CONTRATO_GRID";

         return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}